"use strict";

const Promise = require("bluebird");
const All = require("../graphql-interface/symbols/all");

module.exports = async function mapFromSource(source, ids, mapper) {
	let results = (ids === All || ids == null)
		? await source.load(All)
		: await Promise.map(ids, (id) => source.load(id));

	return results.map(mapper);
};
